--[[
Simple Love2d Game
made by Erik Wallin
]]--


function love.load(arg)

	local screen_width, screen_height = love.graphics.getDimensions()

	entities = {}

	Entity = {}

	function Entity:new(obj)
		obj = obj or {}
		setmetatable(obj, self)
		self.__index = self

		--obj.energy = obj.energy or 100 -- What's a good index for energy? limited to exact number? percent? [0-1] range? arbitrarily high(unlimted)? if unlimited, how to balance? "weight" slows down
		obj.x = obj.x or 0
		obj.y = obj.y or 0
		obj.dirty = false

		table.insert(entities, obj)

		return obj
	end

	function Entity:update()
		self.x = self.x + math.floor(love.math.random(-1, 1))
		self.y = self.y + math.floor(love.math.random(-1, 1))
	end

	function Entity:draw()
		love.graphics.point(self.x+0.5, self.y+0.5)
	end




	for i=1, 1000 do
		tx = love.math.random(5, screen_width-5)
		ty = love.math.random(5, screen_height-5)
		Entity:new({x=tx, y=ty})
	end
end


function love.update(dt)
	-- Move stage
	for i,entity in ipairs(entities) do
		--entity.dirty = false -- doés not change a thing right now, since all entities that are dirty get rmoved
		entity:update()
	end

	-- Check stage
	for i=1, #entities do
		for j=i+1, #entities do
			collision = ((entities[i].x == entities[j].x) or (entities[i].y == entities[j].y))
			entities[i].dirty = collision
			entities[j].dirty = collision
		end
	end

	-- Clean stage
	local ent_len = #entities

	-- set all dirty elements to nil, making the table sparse
	for i,entity in ipairs(entities) do
		if entity.dirty then
		    entities[i] = nil -- remove element
		end
	end

	-- compact the table
	local j = 0
	for i=1,ent_len do
		if entities[i] ~= nil then
			j = j+1
			entities[j] = entities[i]
		end
	end
	for i=j+1, ent_len do
		entities[i]=nil
	end
end


function love.draw(dt)
	for i,entity in ipairs(entities) do
		entity:draw()
	end
end